/****************************************************************
**
** Attal : Lords of Doom
**
** chest.h
** Displays chests on map
**
** Version : $Id: chest.h,v 1.1 2003/08/29 12:48:32 audoux Exp $
**
** Author(s) : Pascal Audoux
**
** Date : 29/08/2003
**
** Licence :    
**	This program is free software; you can redistribute it and/or modify
**   	it under the terms of the GNU General Public License as published by
**     	the Free Software Foundation; either version 2, or (at your option)
**      any later version.
**
**	This program is distributed in the hope that it will be useful,
** 	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
****************************************************************/

 
#ifndef CHEST_H
#define CHEST_H

// generic include files
// include files for QT
#include <qcanvas.h>
// application specific include files
#include "libCommon/genericChest.h"

class GenericCell;


/*              ------------------------------
 *                         Chest
 *              ------------------------------ */

class Chest : public QCanvasSprite, public GenericChest
{

public:
	/** Constructor */
	Chest( QCanvas * canvas );

	void setCell( GenericCell * cell );

	void setupChest();

        static const int RTTI;
	/** Return RTTI */
	int rtti() const { return RTTI; };
};

#endif // CHEST_H
