/****************************************************************
**
** Attal : Lords of Doom
**
** attalSettings.h
**
** Author(s) : Nick Semenov
**
** Date : 05/12/2003
**
** Licence :
**	This program is free software; you can redistribute it and/or modify
**   	it under the terms of the GNU General Public License as published by
**     	the Free Software Foundation; either version 2, or (at your option)
**      any later version.
**
**	This program is distributed in the hope that it will be useful,
** 	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
****************************************************************/


#ifndef ATTALSETTINGS_H
#define ATTALSETTINGS_H


// generic include files

// include files for QT
#include <qsettings.h>
// application specific include files


/*              ------------------------------
 *                         AttalSettings
 *              ------------------------------ */

struct FightSettings
{
	bool IsAnimationEnabled;
	bool AreCellsVisible;
	int AnimationSpeed;
};

struct StrategyModeSettings
{
	bool IsAnimationEnabled;
	bool IsMapVisible;
	bool IsSoundOn;
};

class AttalSettings
{

public:

	AttalSettings()
	{}

static	FightSettings getFightSettings ();
static	void setFightSettings (FightSettings& fightSettings);

static	StrategyModeSettings getStrategyModeSettings ();
static	void setStrategyModeSettings (StrategyModeSettings& strategyModeSettings);
};

#endif // CLASSNAME_H
